/*
** VF[_\[Xt@C̓ǂݍ
*/
#include <iostream>
#include <fstream>

#if defined(WIN32)
#  include "glew.h"
#  include <GL/gl.h>
#elif defined(__APPLE__) || defined(MACOSX)
#  include <OpenGL/gl.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/gl.h>
#endif

#include "glsl.h"

/*
** VF[_̃\[XvOɓǂݍ
*/
int readShaderSource(GLuint shader, const char *name)
{
  int ret; // IXe[^Xi 0 ȂG[j
    
  std::ifstream file(name, std::ios::binary);
  if (file.fail()) {
    std::cerr << "Can't open file: " << name << std::endl;
    ret = -1;
  }
  else {

    // t@C̖Ɉړ݈ʒui܂t@CTCYj𓾂
    file.seekg(0L, std::ios::end);
    GLsizei length = file.tellg();
    
    // t@CTCỸm
    const GLchar *source = new GLchar[length];

    // t@C擪ǂݍ
    file.seekg(0L, std::ios::beg);
    file.read((char *)source, length);
    
    if (file.bad()) {

      // ܂ǂݍ߂Ȃ
      std::cerr << "Could not read file: " << name << std::endl;
      ret = -1;
    }
    else {

      // VF[_̃\[XvÕVF[_IuWFNgւ̓ǂݍ
      glShaderSource(shader, 1, &source, &length);
      ret = 0;
    }
    
    // ǂݍ݂ɎgJ
    delete[] source;
  }
    
  return ret;
}

/*
** VF[_̏\
*/
void printShaderInfoLog(GLuint shader)
{
  // VF[_̃RpC̃O̒擾
  GLsizei bufSize;
  glGetShaderiv(shader, GL_INFO_LOG_LENGTH , &bufSize);
  
  if (bufSize > 1) {
    
    // VF[_̃RpC̃O̓e擾
    GLchar *infoLog = new GLchar[bufSize];
    GLsizei length;
    glGetShaderInfoLog(shader, bufSize, &length, infoLog);
    std::cerr << "InfoLog:\n" << infoLog << '\n' << std::endl;
    delete[] infoLog;
  }
}

/*
** vȌ\
 */
void printProgramInfoLog(GLuint program)
{
  // VF[_̃ÑO̒擾
  GLsizei bufSize;
  glGetProgramiv(program, GL_INFO_LOG_LENGTH , &bufSize);
  
  if (bufSize > 1) {
    
    // VF[_̃ÑO̓e擾
    GLchar *infoLog = new GLchar[bufSize];
    GLsizei length;
    glGetProgramInfoLog(program, bufSize, &length, infoLog);
    std::cerr << "InfoLog:\n" << infoLog << '\n' << std::endl;
    delete[] infoLog;
  }
}
